library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity synch_ram_module is
    Port ( clk_i	: in std_logic;
			  wr_i	: in std_logic; --wr='1' set ram in write mode, wr='0' set ram in read mode
			  oe_i   : in std_logic; -- output enable input
			  addr_i : in  STD_LOGIC_VECTOR (4 downto 0);
           data_io : inout  STD_LOGIC_VECTOR (7 downto 0));
end synch_ram_module;

architecture Behavioral of synch_ram_module is
	type ram_type is array(0 to 31) of std_logic_vector(7 downto 0);
	signal ram:ram_type;
	
	signal data_int : STD_LOGIC_VECTOR (7 downto 0);
	
begin
	-- bidirectional common data bus
	data_io <= data_int when oe_i='1' else (others => 'Z');

	-- latch type process
	process(clk_i)
	begin
		if rising_edge(clk_i) then
			if wr_i='1' and oe_i='0' then
				ram(conv_integer(addr_i)) <= data_io ;
			end if;
			if wr_i='0' then
					data_int <=ram(conv_integer(addr_i));
			end if;
			

		end if;
	end process;

end Behavioral;

