library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity synch_rom is
    Port ( clk_i : in  STD_LOGIC;
           rst_i : in  STD_LOGIC;
           addr_i : in  STD_LOGIC_VECTOR (4 downto 0);
           data_o : out  STD_LOGIC_VECTOR (7 downto 0));
end synch_rom;

architecture Behavioral of synch_rom is
	type rom_type is array(0 to 31) of std_logic_vector(7 downto 0);
	constant rom:rom_type:=(x"00",x"01",x"02",x"03",x"04",x"05",x"06",x"07",x"08",x"09",x"0a",x"0b",x"0c",x"0d",x"0e",x"0f",
									x"10",x"21",x"32",x"43",x"54",x"65",x"76",x"87",x"98",x"a9",x"1a",x"2b",x"3c",x"4d",x"5e",x"0f");

begin
	-- synchronus process describing ROM memory
	process(clk_i,rst_i)
	begin
		if rst_i ='1' then
			data_o <= (others=>'0');
		elsif Rising_Edge(clk_i) then
			data_o <= rom(conv_integer(addr_i)) after 3 ns;
		end if;
	end process;


end Behavioral;

