LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
 
ENTITY tb_arom IS
END tb_arom;
 
ARCHITECTURE behavior OF tb_arom IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT asynch_rom
    PORT(
         addr_i : IN  std_logic_vector(4 downto 0);
         data_o : OUT  std_logic_vector(7 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal addr_i : std_logic_vector(4 downto 0) := (others => '0');

 	--Outputs
   signal data_o : std_logic_vector(7 downto 0);
   
	constant period : time:= 10ns; 

BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: asynch_rom PORT MAP (
          addr_i => addr_i,
          data_o => data_o
        );
 
   -- No clocks detected in port list. Replace <clock> below with 
   -- appropriate port name 
 

	process
	begin
		wait for period; 
		addr_i<=addr_i+1;
	end process;

END;
