LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
 
ENTITY tb_srom IS
END tb_srom;
 
ARCHITECTURE behavior OF tb_srom IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT synch_rom
    PORT(
         clk_i : IN  std_logic;
         rst_i : IN  std_logic;
         addr_i : IN  std_logic_vector(4 downto 0);
         data_o : OUT  std_logic_vector(7 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal clk_i : std_logic := '0';
   signal rst_i : std_logic := '0';
   signal addr_i : std_logic_vector(4 downto 0) := (others => '0');

 	--Outputs
   signal data_o : std_logic_vector(7 downto 0);

   -- Clock period definitions
   constant clk_i_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: synch_rom PORT MAP (
          clk_i => clk_i,
          rst_i => rst_i,
          addr_i => addr_i,
          data_o => data_o
        );

   -- Clock process definitions
   clk_i_process :process
   begin
		clk_i <= '0';
		wait for clk_i_period/2;
		clk_i <= '1';
		wait for clk_i_period/2;
		addr_i<=addr_i+1;
   end process;
 
rst_i<= '1', '0' after 3 ns;

END;
